import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, sanitize

exercise = 'src.calculator'

def parse_result(output):
    if len(output) > 30:
        return output[:30] + "..."
    else:
        return output
#addera, multiplicera,subtrahera(-)
@points('1.calculator')
class CalculatorTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', return_value = '0'):
            cls.module = load_module(exercise, 'en')

    def test_addera1(self):
        with patch('builtins.input', side_effect = [ '1', '2', 'addera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            expect = '1 + 2 = 3'
            self.assertTrue(len(output)>0, "Ditt program skriver inte ut något med input 1, 2, addera")
            self.assertTrue(expect in output, f"Med input 1, 2, addera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")

    def test_addera2(self):
        with patch('builtins.input', side_effect = [ '75', '23', 'addera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            self.assertTrue(len(output)>0, "Ditt program skriver inte ut något med input 75, 23, addera")
            expect = '75 + 23 = 98'
            self.assertTrue(expect in output, f"Med input 75, 23, addera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")

    def test_subtrahera1(self):
        with patch('builtins.input', side_effect = [ '2', '1', 'subtrahera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            self.assertTrue(len(output)>0, "Ditt program skriver inte ut något med input 2, 1, subtrahera")
            expect = '2 - 1 = 1'
            self.assertTrue(expect in output, f"Med input 2, 1, subtrahera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")

    def test_subtrahera2(self):
        with patch('builtins.input', side_effect = [ '13', '34', 'subtrahera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            expect = '13 - 34 = -21'
            self.assertTrue(expect in output, f"Med input 13, 34, subtrahera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")

    def test_multiplicera1(self):
        with patch('builtins.input', side_effect = [ '2', '3', 'multiplicera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            expect = '2 * 3 = 6'
            self.assertTrue(len(output)>0, "Ditt program skriver inte ut något med input 2, 3, multiplicera")
            self.assertTrue(expect in output, f"Med input 2, 3, multiplicera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")
   
    def test_multiplicera2(self):
        with patch('builtins.input', side_effect = [ '27', '-3', 'multiplicera', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            expect = '27 * -3 = -81'
            self.assertTrue(expect in output, f"Med input 27, -3, multiplicera borde ditt program ha skrivits ut\n{expect}\nDitt program skrevs ut:\n{output}")

    def test_xcrap(self):
        with patch('builtins.input', side_effect = [ '27', '-3', 'quotient', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            self.assertTrue(len(output) == 0, f"Med input 27, -3, quotient ska ditt program inte skriva ut någonting\nDitt program skrevs ut:\n{output}")

if __name__ == '__main__':
    unittest.main()
